/*
 *  $VER: CloseAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

/****** asyncio/main/CloseAsync ******************************************
*
*   NAME
*      CloseAsync -- Description
*
*   SYNOPSIS
*      LONG CloseAsync(struct AsyncFile * file);
*
*   FUNCTION
*
*   INPUTS
*       file - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

LONG _AsyncIO_CloseAsync(struct AsyncIOIFace *Self, struct AsyncFile * file) {

  struct AsyncIOBase *libBase = (struct AsyncIOBase *)Self->Data.LibBase;
  
  LONG	result;

  if (file) {
    result = _AsyncIO_WaitPacket(Self,file);
    if (result >= 0) {
      if (!file->af_ReadMode) {
        /* this will flush out any pending data in the write buffer */
        if (file->af_BufferSize > file->af_BytesLeft) {
          result = libBase->IDOS->Write(file->af_File,file->af_Buffers[file->af_CurrentBuf],file->af_BufferSize - file->af_BytesLeft);
        }
      }
    }
    if (file->af_CloseFH) libBase->IDOS->Close(file->af_File);
    IExec->FreeVec(file);
  }
  else {
    libBase->IDOS->SetIoErr(ERROR_INVALID_LOCK);
    result = -1;
  }

  return(result);

}

