/*
 *  $VER: FGetsLenAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

#include <clib/debug_protos.h>

/****** asyncio/main/FGetsLenAsync ******************************************
*
*   NAME
*      FGetsLenAsync -- Description
*
*   SYNOPSIS
*      STRPTR FGetsLenAsync(struct AsyncFile * file, STRPTR buf, LONG bytes, LONG * length);
*
*   FUNCTION
*
*   INPUTS
*       file - 
*       buf - 
*       bytes - 
*       length - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

STRPTR _AsyncIO_FGetsLenAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, STRPTR buf, LONG bytes, LONG *len) {

  UBYTE	*p;
  LONG length = 0;

  p = (UBYTE *)buf;

  /* Make room for \n and \0 */
  if (--bytes <= 0) return(0); /* Handle senseless cases */

  while(TRUE) {
    UBYTE	*ptr;
    LONG	i, count;
    ptr = (UBYTE *)file->af_Offset;
    if ((count = file->af_BytesLeft) != 0) {
      count = MIN(count,bytes);
      for(i = 0; (i < count) && (*ptr != '\n'); i++) *p++ = *ptr++;
      length += i;
      /* Check for valid EOL char */
      if (i < count) {
        /* MH: Since i < count, and count <= numBytes,
         * there _is_ room for \n\0.
         */
        *p++ = '\n';	/* "Read" EOL char */
        ++i;
        length += 1;
      }
      file->af_BytesLeft -= i;
      file->af_Offset    += i;
      if ((i >= bytes) || (*(p - 1) == '\n')) break;
      bytes -= i;
    }
    /* MH: numBytes must be at least 1 here, so there is still room
     * for \n\0, in case we read \n.
     */
    if (_AsyncIO_ReadAsync(Self,file,p,1) < 1) break;
    --bytes;
    ++length;
    if (*p++ == '\n') break;
  }

  *p = '\0';
  *len = length;

  if (p == (UBYTE *)buf) return(0);

  return(buf);

}

