#ifndef INIT_H
#define INIT_H

#include <stdarg.h>

#include <exec/exec.h>

#include <dos/dos.h>

#include <libraries/asyncio.h>

#include <proto/asyncio.h>
#include <proto/dos.h>
#include <proto/exec.h>

struct AsyncIOBase {
  struct Library libNode;
  BPTR segList;
  struct Library *DOSBase;
  struct DOSIFace *IDOS;
  /* If you need more data fields, add them here */
};

struct ExecIFace *IExec;

struct AsyncFile *_AsyncIO_OpenAsyncFH(struct AsyncIOIFace *Self, BPTR handle, LONG mode, LONG bufferSize, BOOL closeIt);
VOID              _AsyncIO_SendPacket(struct AsyncFile *file, APTR arg2);
LONG              _AsyncIO_WaitPacket(struct AsyncIOIFace *Self, struct AsyncFile *file);
VOID              _AsyncIO_RecordSyncFailure(struct AsyncIOIFace *Self, struct AsyncFile *file);
VOID              _AsyncIO_RequeuePacket(struct AsyncFile *file);

LONG              _AsyncIO_WriteAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, APTR buffer, LONG bytes);
LONG              _AsyncIO_ReadAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, APTR buffer, LONG bytes);
STRPTR            _AsyncIO_FGetsLenAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, STRPTR buf, LONG bytes, LONG * length);

#ifndef MIN
#define MIN(a,b) ((a) < (b) ? (a) : (b))
#endif

#endif // INIT_H

