/*
 *  $VER: OpenAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

/****** asyncio/main/OpenAsync ******************************************
*
*   NAME
*      OpenAsync -- Description
*
*   SYNOPSIS
*      struct AsyncFile * OpenAsync(STRPTR fileName, ULONG mode, LONG bufferSize);
*
*   FUNCTION
*
*   INPUTS
*       fileName - 
*       mode - 
*       bufferSize - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

struct AsyncFile *_AsyncIO_OpenAsync(struct AsyncIOIFace *Self, STRPTR fileName, ULONG mode, LONG bufferSize) {

  static const LONG privateOpenModes[] = {
    MODE_OLDFILE, MODE_NEWFILE, MODE_READWRITE
  };
  
  BPTR handle;
  
  struct AsyncIOBase *libBase = (struct AsyncIOBase *)Self->Data.LibBase;
  
  struct AsyncFile	*file = NULL;
  
  if ((handle = libBase->IDOS->Open(fileName,privateOpenModes[mode])) != 0) {
    file = _AsyncIO_OpenAsyncFH(Self,handle,mode,bufferSize,TRUE);
    if (!file) libBase->IDOS->Close(handle);
  }

	return(file);

}

