/*
 *  $VER: PeekAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

/****** asyncio/main/PeekAsync ******************************************
*
*   NAME
*      PeekAsync -- Description
*
*   SYNOPSIS
*      LONG PeekAsync(struct AsyncFile * file, APTR buffer, LONG bytes);
*
*   FUNCTION
*
*   INPUTS
*       file - 
*       buffer - 
*       bytes - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

LONG _AsyncIO_PeekAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, APTR buffer, LONG numBytes) {

  /* Try to fill a new buffer, if needed */
  if (!file->af_BytesLeft) {
    LONG	bytes;
    if ((bytes = _AsyncIO_ReadAsync(Self,file,&bytes,1)) <= 0) return(bytes);
    /* Unread byte */
    --file->af_Offset;
    ++file->af_BytesLeft;
  }

  /* Copy what we can */
  numBytes = MIN(numBytes,file->af_BytesLeft);
  
  IExec->CopyMem(file->af_Offset,buffer,numBytes);

  return(numBytes);

}

