/*
 *  $VER: ReadAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

/****** asyncio/main/ReadAsync ******************************************
*
*   NAME
*      ReadAsync -- Description
*
*   SYNOPSIS
*      LONG ReadAsync(struct AsyncFile * file, APTR buffer, LONG bytes);
*
*   FUNCTION
*
*   INPUTS
*       file - 
*       buffer - 
*       bytes - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

LONG _AsyncIO_ReadAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, APTR buffer, LONG bytes) {

  LONG totalBytes   = 0;
  LONG bytesArrived = 0;

  /* if we need more bytes than there are in the current buffer, enter the
   * read loop
   */
  while(bytes > file->af_BytesLeft) {
    /* drain buffer */
    IExec->CopyMem(file->af_Offset,buffer,file->af_BytesLeft);
    bytes -= file->af_BytesLeft;
    buffer = (APTR)((ULONG)buffer + file->af_BytesLeft);
    totalBytes += file->af_BytesLeft;
    file->af_BytesLeft = 0;
    bytesArrived = _AsyncIO_WaitPacket(Self,file);
    if (bytesArrived <= 0) {
      if (bytesArrived == 0) return(totalBytes);
      return(-1);
    }
    /* ask that the buffer be filled */
    _AsyncIO_SendPacket(file,file->af_Buffers[1 - file->af_CurrentBuf]);
    /* in case we tried to seek past EOF */
    if (file->af_SeekOffset > bytesArrived) file->af_SeekOffset = bytesArrived;
    file->af_Offset     = file->af_Buffers[file->af_CurrentBuf] + file->af_SeekOffset;
    file->af_CurrentBuf = 1 - file->af_CurrentBuf;
    file->af_BytesLeft  = bytesArrived - file->af_SeekOffset;
    file->af_SeekOffset = 0;
  }

  IExec->CopyMem(file->af_Offset,buffer,bytes);

  file->af_BytesLeft -= bytes;
  file->af_Offset    += bytes;

  return(totalBytes + bytes);

}

