/*
 *  $VER: ReadCharAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

/****** asyncio/main/ReadCharAsync ******************************************
*
*   NAME
*      ReadCharAsync -- Description
*
*   SYNOPSIS
*      LONG ReadCharAsync(struct AsyncFile * file);
*
*   FUNCTION
*
*   INPUTS
*       file - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

LONG _AsyncIO_ReadCharAsync(struct AsyncIOIFace *Self, struct AsyncFile *file) {

  UBYTE	ch;

  if (file->af_BytesLeft) {
    /* if there is at least a byte left in the current buffer, get it
     * directly. Also update all counters
     */
    ch = *file->af_Offset;
    --file->af_BytesLeft;
    ++file->af_Offset;
    return((LONG)ch);
  }

  /* there were no characters in the current buffer, so call the main read
   * routine. This has the effect of sending a request to the file system to
   * have the current buffer refilled. After that request is done, the
   * character is extracted for the alternate buffer, which at that point
   * becomes the "current" buffer
   */

  if (_AsyncIO_ReadAsync(Self,file,&ch,1) > 0) return((LONG)ch);

  /* We couldn't read above, so fail */

  return(-1);

}

