/*
 *  $VER: ReadLineAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

#include <clib/debug_protos.h>

/****** asyncio/main/ReadLineAsync ******************************************
*
*   NAME
*      ReadLineAsync -- Description
*
*   SYNOPSIS
*      LONG ReadLineAsync(struct AsyncFile * file, STRPTR buf, LONG bytes);
*
*   FUNCTION
*
*   INPUTS
*       file - 
*       buf - 
*       bytes - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

LONG _AsyncIO_ReadLineAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, STRPTR buf, LONG bytes) {

  LONG len = 0;

  /* First read any data up to the LF or the buffer is full */
  if (_AsyncIO_FGetsLenAsync(Self,file,buf,bytes,&len)) {
    UBYTE	*end;
    end = ((UBYTE *)buf) + len - 1;
    if (*end != '\n') {
      UBYTE	ch = 0;
      /* We didn't reach EOF yet */
      while(TRUE) {
        UBYTE	*ptr;
        LONG	i, count;
        ptr = (UBYTE *)file->af_Offset;
        if ((count = file->af_BytesLeft) != 0)	{
          /* Scan for LF char in buffer */
          for(i = 0; (i < count) && (*ptr != '\n'); ++i, ++ptr) { }
          /* If i < count, then the loop above aborted
           * due to LF char.
           */
          if (i < count) {
            ch = '\n';
            ++i;
          }
          file->af_BytesLeft -= i;
          file->af_Offset    += i;
          if (i < count) break; /* All done */
        }
        if (_AsyncIO_ReadAsync(Self,file,&ch,1) < 1) break;
        if (ch == '\n') break; /* All done */
      }
      if (ch == '\n') {
        /* Overwrite last char with LF */
        *end++ = '\n';
        *end = '\0';
      }
    }
  }

  return(len);

}

