/*
 *  $VER: WriteAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

/****** asyncio/main/WriteAsync ******************************************
*
*   NAME
*      WriteAsync -- Description
*
*   SYNOPSIS
*      LONG WriteAsync(struct AsyncFile * file, APTR buffer, LONG bytes);
*
*   FUNCTION
*
*   INPUTS
*       file - 
*       buffer - 
*       bytes - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

LONG _AsyncIO_WriteAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, APTR buffer, LONG bytes) {

  LONG totalBytes = 0;

  /* this takes care of NIL: */
  if (!file->af_Handler) {
    file->af_Offset    = file->af_Buffers[0];
    file->af_BytesLeft = file->af_BufferSize;
    return(bytes);
  }

  while(bytes > file->af_BytesLeft) {
    if (file->af_BytesLeft) {
      IExec->CopyMem(buffer,file->af_Offset,file->af_BytesLeft);
      bytes	-= file->af_BytesLeft;
      buffer = (APTR)((ULONG)buffer + file->af_BytesLeft);
      totalBytes	+= file->af_BytesLeft;
    }
    if (_AsyncIO_WaitPacket(Self,file) < 0) return(-1);
    /* send the current buffer out to disk */
    _AsyncIO_SendPacket(file,file->af_Buffers[file->af_CurrentBuf]);
    file->af_CurrentBuf	= 1 - file->af_CurrentBuf;
    file->af_Offset = file->af_Buffers[file->af_CurrentBuf];
    file->af_BytesLeft = file->af_BufferSize;
  }

  IExec->CopyMem(buffer,file->af_Offset,bytes);

  file->af_BytesLeft -= bytes;
  file->af_Offset    += bytes;

  return(totalBytes + bytes);

}

