/*
 *  $VER: WriteCharAsync.c $Revision$ (28-Dec-2003)
 *
 *  This file is part of asyncio.
 *
 *  (C) Copyright 2003 Hyperion Entertainment
 *      All rights reserved
 *
 * $Id$
 *
 * $Log$
 *
 *
 */

#include "init.h"

/****** asyncio/main/WriteCharAsync ******************************************
*
*   NAME
*      WriteCharAsync -- Description
*
*   SYNOPSIS
*      LONG WriteCharAsync(struct AsyncFile * file, ULONG ch);
*
*   FUNCTION
*
*   INPUTS
*       file - 
*       ch - 
*
*   RESULT
*       The result ...
*
*   EXAMPLE
*
*   NOTES
*
*   BUGS
*
*   SEE ALSO
*
*****************************************************************************
*
*/

LONG _AsyncIO_WriteCharAsync(struct AsyncIOIFace *Self, struct AsyncFile *file, ULONG ch) {

  if (file->af_BytesLeft) {
    /* if there's any room left in the current buffer, directly write
     * the byte into it, updating counters and stuff.
     */
    *file->af_Offset = ch;
    --file->af_BytesLeft;
    ++file->af_Offset;
    /* one byte written */
    return(1);
  }
  else {
    /* there was no room in the current buffer, so call the main write
     * routine. This will effectively send the current buffer out to disk,
     * wait for the other buffer to come back, and then put the byte into
     * it.
     */
    return(_AsyncIO_WriteAsync(Self,file,&ch,1));
  }

}

