#include <stdio.h>

#include <libraries/asyncio.h>

#include <proto/asyncio.h>
#include <proto/dos.h>
#include <proto/exec.h>

struct AsyncIOBase *AsyncIOBase = 0;

struct AsyncIOIFace *IAsyncIO = 0;

int main(int argc, char *argv[]) {
  
  struct AsyncFile *write_fh = 0;
  
  LONG bytes = 0;
  
  STRPTR line = "This is a test.";
  
  if (!(AsyncIOBase = (struct AsyncIOBase *)IExec->OpenLibrary("asyncio.library",50))) {
    IDOS->Printf("\nFailed to load asyncio.library v50.\n\n");
    return(20);
  }

  if (!(IAsyncIO = (struct AsyncIOIFace *)IExec->GetInterface((struct Library *)AsyncIOBase,"main",1,TAG_DONE))) {
    IDOS->Printf("\nFailed to Get AsyncIO Interface.\n\n");
    IExec->CloseLibrary((struct Library *)AsyncIOBase);
    return(20);
  }
  
  IDOS->Printf("\nSuccessfully opened AsyncIO Library and Interface.\n");
  
  if ((write_fh = IAsyncIO->OpenAsync("testasync.txt",MODE_WRITE,32768)) == 0) {
    IDOS->Printf("\nUnable to open your file: testasync.txt\n\n");
  }
  else {
    IDOS->Printf("Successfully opened the file.\n");
    bytes = IAsyncIO->WriteLineAsync(write_fh,line);
    IDOS->Printf("Successfully wrote %ld bytes to the file.\n",bytes);
    bytes = IAsyncIO->WriteCharAsync(write_fh,'\n');
    IDOS->Printf("Successfully wrote %ld byte to the file.\n\n",bytes);
    IAsyncIO->CloseAsync(write_fh);
  }

  IExec->DropInterface((struct Interface *)IAsyncIO);
  IExec->CloseLibrary((struct Library *)AsyncIOBase);

  return(0);
  
}

